> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developers.awork.com/apiv1/project-automations/put-project-automation/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server. # Updates the automation with the specified id. PUT https://api.awork.com/api/v1/projects/{projectId}/automations/{automationId} Content-Type: application/json Updates the automation with the specified id. The user needs to be the owner of the project or have 'write' permissions of the feature 'project-master-data' globally or in the project. If the automation was created from a workflow, only the Enabled flag can be changed.Any authenticated user. Reference: https://developers.awork.com/apiv1/project-automations/put-project-automation ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `automationId` (string, required) — The id of the automation. - `projectId` (string, required) — The id of the project. ### Body (application/json) This endpoint expects an AutomationPutForm. - `enabled` (boolean, required) — Whether the automation is enabled. - `trigger` (AutomationTriggerForm, required) ## Response ### 200 OK - `id` (string, optional) — The id of the automation. - `createdBy` (string, optional) — The id of the user who created the automation. - `createdOn` (string, optional) — The date the automation was created. - `updatedBy` (string, optional) — The id of the user who updated the automation. - `updatedOn` (string, optional) — The date the automation was updated. - `triggerId` (string, optional) — The id of the trigger which is related to the automation. - `trigger` (Trigger, optional) - `enabled` (boolean, optional) — Whether the automation is enabled. - `state` (string, optional, nullable) — The state of the automation. See AutomationsService.DAL.Models.AutomationState for the possible values. - `createdByProjectTemplate` (boolean, optional) — Whether the automation was created from an automation template of a project template. - `projectId` (string, optional, nullable) — The id of the project which is related to the automation. - `projectTemplateId` (string, optional, nullable) — The id of the project template which is related to the automation. - `actions` (list of Action, optional, nullable) — The actions which is related to the automation. - `workflowId` (string, optional, nullable) — The workflow this automation belongs to, if any. - `createdByAutomationIdFromWorkflow` (string, optional, nullable) — The id of the workflow automation that served as the template for this automation. - `failed` (ErrorResponse, optional) — The API error response. ## Errors ### 400 Bad Request Error Bad Request - `code` (string, required) — The error code. - `description` (string, required) — The description of the error. - `link` (string, required) — The link to the API documentation page. - `details` (list of string, optional, nullable) — A list of details describing the error. - `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property. - `traceId` (string, optional, nullable) — The request trace id for tracking the request. ## Types ### AutomationTriggerForm - `type` (string, required) — The type of the trigger. - `values` (list of AutomationTriggerValueForm, optional, nullable) — The values of the trigger. ### Trigger - `updatedOn` (string, optional) — The date the trigger was updated. - `type` (string, optional, nullable) — The type of the trigger. - `values` (list of TriggerValue, optional, nullable) — The values of the trigger. ### Action - `id` (string, optional) — The id of the action. - `createdBy` (string, optional) — The id of the user who created the action. - `createdOn` (string, optional) — The date the action was created. - `updatedBy` (string, optional) — The id of the user who updated the action. - `updatedOn` (string, optional) — The date the action was updated. - `type` (string, optional, nullable) — The type of the action. - `order` (double, optional, nullable) — The order of the action. - `values` (list of ActionValue, optional, nullable) — The values of the action. ### ErrorResponse The API error response. - `code` (string, required) — The error code. - `description` (string, required) — The description of the error. - `link` (string, required) — The link to the API documentation page. - `details` (list of string, optional, nullable) — A list of details describing the error. - `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property. - `traceId` (string, optional, nullable) — The request trace id for tracking the request. ### ValidationErrorResponse The validation error response. - `property` (string, optional, nullable) — The name of the property that failed validation. - `message` (string, optional, nullable) — The reason why this property failed validation. ### AutomationTriggerValueForm - `name` (string, required) — The name of the trigger value. - `value` (any, required) — The value of the trigger value. ### TriggerValue - `name` (string, optional, nullable) — The name of the trigger value. - `value` (string, optional, nullable) — The value of the trigger value. ### ActionValue - `name` (string, optional, nullable) — The name of the action value. - `value` (string, optional, nullable) — The value of the action value. ## Examples **Request** ```json { "enabled": true, "trigger": { "type": "task-created" } } ``` **Response** ```json { "id": "123e4567-e89b-12d3-a456-426614174000", "createdBy": "123e4567-e89b-12d3-a456-426614174000", "createdOn": "2024-01-15T09:30:00Z", "updatedBy": "123e4567-e89b-12d3-a456-426614174000", "updatedOn": "2024-01-15T09:30:00Z", "triggerId": "123e4567-e89b-12d3-a456-426614174000", "trigger": { "updatedOn": "2024-01-15T09:30:00Z", "type": "task-created", "values": [ { "name": "name", "value": "Design" } ] }, "enabled": true, "state": "string", "createdByProjectTemplate": false, "projectId": "123e4567-e89b-12d3-a456-426614174000", "projectTemplateId": "123e4567-e89b-12d3-a456-426614174000", "actions": [ { "id": "123e4567-e89b-12d3-a456-426614174000", "createdBy": "123e4567-e89b-12d3-a456-426614174000", "createdOn": "2024-01-15T09:30:00Z", "updatedBy": "123e4567-e89b-12d3-a456-426614174000", "updatedOn": "2024-01-15T09:30:00Z", "type": "tag-add-task", "order": 2, "values": [ { "name": "tag", "value": "Design" } ] } ], "workflowId": "123e4567-e89b-12d3-a456-426614174000", "createdByAutomationIdFromWorkflow": "123e4567-e89b-12d3-a456-426614174000", "failed": { "code": "not-found", "description": "There is no matching path for this URL.", "link": "https://developers.awork.com", "details": [ "No project with the id '123' exists." ], "validationErrors": [ { "property": "FirstName", "message": "FirstName is required." } ], "traceId": "a65ce5745df02af216715ff06661fb3a" } } ``` **SDK Code** ```python import requests url = "https://api.awork.com/api/v1/projects/projectId/automations/automationId" payload = { "enabled": True, "trigger": { "type": "task-created" } } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.awork.com/api/v1/projects/projectId/automations/automationId'; const options = { method: 'PUT', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"enabled":true,"trigger":{"type":"task-created"}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.awork.com/api/v1/projects/projectId/automations/automationId" payload := strings.NewReader("{\n \"enabled\": true,\n \"trigger\": {\n \"type\": \"task-created\"\n }\n}") req, _ := http.NewRequest("PUT", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.awork.com/api/v1/projects/projectId/automations/automationId") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"enabled\": true,\n \"trigger\": {\n \"type\": \"task-created\"\n }\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://api.awork.com/api/v1/projects/projectId/automations/automationId") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"enabled\": true,\n \"trigger\": {\n \"type\": \"task-created\"\n }\n}") .asString(); ``` ```php request('PUT', 'https://api.awork.com/api/v1/projects/projectId/automations/automationId', [ 'body' => '{ "enabled": true, "trigger": { "type": "task-created" } }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.awork.com/api/v1/projects/projectId/automations/automationId"); var request = new RestRequest(Method.PUT); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"enabled\": true,\n \"trigger\": {\n \"type\": \"task-created\"\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "enabled": true, "trigger": ["type": "task-created"] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/projects/projectId/automations/automationId")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PUT" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```